'//////////////////////////////////////////////////////////
'///    FastAVR Basic Compiler for AVR by MICRODESIGN   ///
'///    LCD on glass 12x3 chars driven by I2C           ///
'///	LcdI2c.bas                    www.FastAVR.com   ///
'//////////////////////////////////////////////////////////
$Device= 8515
$Stack = 32
$Clock = 7,3728
$I2C SDA=PORTA.1, SCL=PORTA.0
$Source=On

Dim s As String*12	' LCD buffer, must be first!
Dim n As Byte

Declare Sub IniLCD()
Declare Sub WrLCD()
Declare Sub LocateLCD(r As Byte, c As Byte)

s="Test for LCD"
IniLCD()
WrLCD() 
Do
	For n=0 To 255
		s=Str(n)
		LocateLCD(3,1)
		WrLCD() 
		WaitMs 250
	Next
	LocateLCD(3,1)
	s="            "		
	WrLCD() 
Loop   

'///////////////////////////////////////////////////
Sub IniLCD()
I2Cstart &h74
I2Cwrite 0; &h2e; &h2; &h06; &h0e
I2Cstop
End Sub     

'///////////////////////////////////////////////////
Sub LocateLCD(r As Byte, c As Byte)	' r: 1 to 3
Local a As Byte                     ' c: 1 to 12

Select Case r
	Case 1				' first line
		a=&h01+c
	Case 2				' secont line
		a=&h9f+c
	Case 3				' third line
		a=&hbf+c
End Select
I2Cstart &h74
I2Cwrite 0; a
I2Cstop
End Sub
   
'///////////////////////////////////////////////////
Sub WrLCD()					' writes str var s on LCD
Local ch As Byte, i As Byte

i=0
I2Cstart &h74            	' generate start
I2Cwrite &h40				' command
Do
	ch=Peek(&h60+i)			' &h60 is adr of s
	ch=ch Or &h80			' up side chars
	If ch=&h80 Then			' chech for end of s
		Exit Do
	End If
	I2Cwrite ch     		' write char 
	Incr i
Loop
I2Cstop
End Sub

